unit Udbgriddemo;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Data.DB, Datasnap.DBClient, WEBLib.CDS,
  WEBLib.DB, Vcl.Controls, Vcl.Grids, WEBLib.DBCtrls, Vcl.StdCtrls,
  WEBLib.StdCtrls, WEBLib.Grids, WEBLib.REST;

type
  TForm1 = class(TWebForm)
    WebDBGrid1: TWebDBGrid;
    WebClientConnection1: TWebClientConnection;
    WebDataSource1: TWebDataSource;
    WebClientDataSet1: TWebClientDataSet;
    WebClientDataSet1Brand: TStringField;
    WebClientDataSet1Model: TStringField;
    WebClientDataSet1Hp: TIntegerField;
    WebClientDataSet1Maxspeed: TIntegerField;
    WebClientDataSet1City: TStringField;
    WebClientDataSet1Country: TStringField;
    WebClientDataSet1Type: TStringField;
    WebClientDataSet1Picture: TStringField;
    WebClientDataSet1Year: TIntegerField;
    WebClientDataSet1Price: TIntegerField;
    WebClientDataSet1Cylinders: TIntegerField;
    WebClientDataSet1URL: TStringField;
    WebClientDataSet1Stock: TIntegerField;
    WebLabel1: TWebLabel;
    WebLabel2: TWebLabel;
    WebButton1: TWebButton;
    WebLabel3: TWebLabel;
    procedure WebDBGrid1FixedCellClick(Sender: TObject; ACol, ARow: Integer);
    procedure WebClientDataSet1PictureGetText(Sender: TField; var Text: string;
      DisplayText: Boolean);
    procedure WebClientDataSet1URLGetText(Sender: TField; var Text: string;
      DisplayText: Boolean);
    procedure WebFormCreate(Sender: TObject);
    procedure WebDBGrid1GetCellEditor(Sender: TObject; ACol, ARow: Integer;
      var AEditor: TGridCellEditor);
    procedure WebButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.WebButton1Click(Sender: TObject);
begin
WebClientConnection1.Active := false;
WebClientDataSet1.Active :=false;

WebClientConnection1.Active := false;
WebClientDataSet1.Active := true;  //The problem is with this line of code

end;

procedure TForm1.WebClientDataSet1PictureGetText(Sender: TField;
  var Text: string; DisplayText: Boolean);
begin
  if (Sender.AsString <> '') then
    Text := 'https://download.tmssoftware.com/tmsweb/demos/TMSWEB_ResponsiveGrid/img/' + StringReplace(Sender.AsString, '.jpg', '_96.jpg', [rfReplaceAll])
  else
    Text := '';
end;

procedure TForm1.WebClientDataSet1URLGetText(Sender: TField; var Text: string;
  DisplayText: Boolean);
begin
  if (Sender.AsString <> '') then
    Text := 'https://' + Sender.AsString
  else
    Text := '';
end;

procedure TForm1.WebDBGrid1FixedCellClick(Sender: TObject; ACol, ARow: Integer);
var
  LIndex: string;
  desc: boolean;
  opt: TIndexOptions;
begin
  if ACol < WebDBGrid1.FixedCols then
    Exit;

  Lindex := 'By'+ WebDBGrid1.Columns[ACol - WebDBGrid1.FixedCols].DataField;

  // toggle sort order when the same column is clicked
  desc := SameText(webclientdataset1.ActiveIndex, LIndex);

  if desc then
    LIndex := LIndex + 'Desc';

  opt := [];

  if desc then
    opt := opt + [ixDescending];

  // clear any previous indexes and add the new index to sort
  webclientdataset1.Indexes.Clear;
  webclientdataset1.Indexes.Add(LIndex, WebDBGrid1.Columns[ACol - WebDBGrid1.FixedCols].DataField, opt);
  webclientdataset1.ActiveIndex := LIndex;

  // set the sort indicator in the grid column header
  if ixDescending in webclientdataset1.Indexes.Find(Lindex).Options then
    WebDBGrid1.Columns[ACol - WebDBGrid1.FixedCols].SortIndicator := siDescending
  else
    WebDBGrid1.Columns[ACol - WebDBGrid1.FixedCols].SortIndicator := siAscending;
end;

procedure TForm1.WebDBGrid1GetCellEditor(Sender: TObject; ACol, ARow: Integer;
  var AEditor: TGridCellEditor);
begin
  if acol = 2 then
    AEditor := TGridCellEditor.geNone;


end;

procedure TForm1.WebFormCreate(Sender: TObject);
begin
  WebDBGrid1.ColWidths[0] := 24;
  WebDBGrid1.RowHeights[0] := 24;
end;

end.
